import React from "react";
import classNames from "classnames";
import { makeStyles } from "@material-ui/core/styles";
import { QueryClient, QueryClientProvider, useQuery } from 'react-query'

import Header from "components/Header/Header.js";
import HeaderLinks from "components/Header/HeaderLinks.js";
import Footer from "components/Footer/Footer.js";
import Parallax from "components/Parallax/Parallax.js";
import styles from "assets/jss/nextjs-material-kit/pages/components.js";

import GetDataAccessories from "../../../api/product/accessories.js";
import DataAccessories from "../../../pages-sections/yamaha/product/accessories.js";
import DataSnackbarContent from "../../../pages-sections/yamaha/snackbar.js";
import Router from 'next/router'
import Cookies from "cookies";

const useStyles = makeStyles(styles);
const queryClient = new QueryClient();
const handleName = values => {
    Router.push({
        pathname: 'yamaha/product/accessories',
        query: (values&&values.length!=0)?{ filter: values[0]["name"] }:{},
    })
}
const Accessories = function ({ selected, accessories, backend, user, ...props }) {
    const classes = useStyles();
    const { ...rest } = props;
    return (
        <div>
        <Header
            rightLinks={<HeaderLinks username={user} />}
            fixed
            color="info"
            changeColorOnScroll={{
            height: 400,
            color: "white",
            }}
            {...rest}
        />
        <Parallax image={require("assets/img/yamalube.jpg")} height="200px"/>
        <div className={classNames(classes.main, classes.mainRaised)}>
            <QueryClientProvider client={queryClient}>
                <DataSnackbarContent/>
                <DataAccessories selected={(selected=="")?null:selected[0]["id"]} handleName={handleName} accessories={accessories} backend={backend} />
            </QueryClientProvider>
        </div>
        <Footer />
        </div>
    );
};

export default Accessories;

export async function getServerSideProps(context) {
    var accessories = [];
    var filter = context.query.filter||"";
    var selected = "";

    const backend = process.env.BACKEND_SERVER_URI;
    
    var { req, resp } = context;
    const cookies = new Cookies(req, resp);
    var user = "";
    var userObj = (await cookies.get("user"))
        ? JSON.parse(await cookies.get("user"))
        : null;
    if (userObj) {
        let sessionId = userObj["partners_login_states"].filter(function (i) {
        return (
            i.business_partner && i.business_partner.name.toUpperCase() == "YAMAHA"
        );
        });
        if (sessionId.length != 0) user = userObj["username"];
    }

    var res = await GetDataAccessories.GetAccessories(filter);
    if (res["STATUS"] === 1) {
        accessories = res["DATA"]["accessories"];
        if (filter !=""){
            selected = accessories.filter((i)=>i.name==filter);
        }
    }

    return { 
        props: { selected, accessories, backend, user }, // will be passed to the page component as props
    };
}